<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>

    <span>
      <button v-on:click="$emit('up')">EasyCloud</button>
    </span>

    <span>
      &gt;
      <button v-on:click="provider=null; edit=false">Providers</button>
    </span>

    <span v-if="provider">
      &gt;
      <button>{{provider.name}}</button>
    </span>
  
    <v-divider/>
    
    <ProvidersList
      v-if = "(provider==null || provider.id==null) && edit==false"
      v-on:selected = "provider=$event"
      v-on:edit = "edit=true; provider=$event"
    />

    <ProviderViewer
      :providerId = "provider.id"
      v-if="provider!=null && provider.id!=null && edit==false"
      v-on:edit="edit=true; provider=$event"
      v-on:deleted="edit=false; provider=null"
      v-on:clone="edit=true; provider=$event; provider.id=null; provider.name='Copy of '+provider.name; provider.grants={owner:'me'}"
    />

    <ProviderEditor
      :provider = "provider"
      v-if="provider!=null && edit==true"
      v-on:view="edit=false; provider=$event"
    />

  </v-container>

</template>

<script>

import ProvidersList from './ProvidersList.vue';
import ProviderViewer from './ProviderViewer.vue';
import ProviderEditor from './ProviderEditor.vue';

export default {

  name: 'VProvidersMain',

  components: {
    ProvidersList,
    ProviderViewer,
    ProviderEditor
  },

  data: () => ({
    edit: false,
    provider: null
  })

};

</script>
